#
# tkmultilistbox.rb : ޥꥹȥܥåå
#                       2000/05/10  Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
# ʣĤΥꥹȥܥåȤˤʤä
# ٤ƤΥꥹȥܥåϰĤνĥСǥȥ뤵
# ƥꥹȥܥåϤ줾˲С
#
require 'tk'

class MultiListbox<TkListbox
  include TkComposite

  # 롼
  #   lbox_height : ꥹȥܥåι⤵(pixel)
  #   title_info  : [ȥʸ, ] 
  #   keys        : ° Hash
  def initialize_composite(lbox_height, title_info, keys={})
    # å
    if (! title_info.kind_of? Array) or (title_info.size < 2)
      raise
    end

    # γ
    @width_total = 0
    title_info.each{|title, width| @width_total += width.to_f}

    # ĥС
    @v_scroll = TkScrollbar.new(@frame, 'orient'=>'vertical')

    # ξݻν
    @base_list = []
    @rel_list   = []
    @title_list = []
    @lbox_list  = []
    @hscr_list  = []

    # ٥̾ȥǥåȤбݻ
    @name_index = {}

    # Ȥʤե졼
    @f_title = TkFrame.new(@frame, 'width'=>@width_total)
    @f_lbox  = TkFrame.new(@frame, 
			   'width'=>@width_total, 'height'=>lbox_height)
    @f_hscr  = TkFrame.new(@frame, 'width'=>@width_total, 
			   'height'=>@v_scroll.cget('width') + 
			             2 * @v_scroll.cget('borderwidth'))

    # ȥι⤵ݤΤΥߡ٥
    TkLabel.new(@f_title, 'text'=>' ').pack

    # 
    sum = 0.0
    @rel_list << sum/@width_total
    title_info.each_with_index{|(label, width), idx|
      # ٥ȥǥåȤбդ
      if @name_index.include?(label)
	@name_index[label] << idx
      else
	@name_index[label] = [idx]
      end

      # а֤η׻
      sum += width
      @rel_list << sum/@width_total

      # ȥե
      f = TkFrame.new(@f_title, 'width'=>width)
      base = [f]
      @title_list << TkLabel.new(f, 'text'=>label).pack('fill'=>'x')
      f.place('relx'=>@rel_list[idx], 'y'=>0, 'anchor'=>'nw', 'width'=>-6, 
	      'relwidth'=>@rel_list[idx+1] - @rel_list[idx])

      # ꥹȥܥåե
      f = TkFrame.new(@f_lbox, 'width'=>width)
      base << f
      @lbox_list << TkListbox.new(f).pack('fill'=>'both', 'expand'=>true)
      f.place('relx'=>@rel_list[idx], 'y'=>0, 'anchor'=>'nw', 'width'=>-4, 
	      'relwidth'=>@rel_list[idx+1] - @rel_list[idx], 'relheight'=>1.0)

      # Сե
      f = TkFrame.new(@f_hscr, 'width'=>width)
      base << f
      @hscr_list << TkScrollbar.new(f, 'orient'=>'horizontal') . 
	                                      pack('fill'=>'x', 'anchor'=>'w')
      f.place('relx'=>@rel_list[idx], 'y'=>0, 'anchor'=>'nw', 'width'=>-4, 
	      'relwidth'=>@rel_list[idx+1] - @rel_list[idx])

      @lbox_list[idx].xscrollcommand proc{|first, last| 
	@hscr_list[idx].set first, last
      }
      @hscr_list[idx].command proc{|args| @lbox_list[idx].xview *args}

      # ɲ
      @base_list << base
    }

    # Ĵ֤
    @tab_list = [nil]
    (1..(@rel_list.size - 2)).each{|idx|
      tab = TkFrame.new(@f_title, 'cursor'=>'crosshair', 'width'=>6, 
			'borderwidth'=>2, 'relief'=>'raised')
      @tab_list << tab
      tab.place('relx'=>@rel_list[idx], 'anchor'=>'ne', 'relheight'=>0.95)
      tab.bind('Button-1', 
	       proc{|x| @x = x; @frame_width = TkWinfo.width(@f_title).to_f}, 
	       '%X')
      tab.bind('B1-Motion', proc{|x, idx| resize(x, idx)}, "%X #{idx}")
    }

    # Сбط
    @lbox_list.each{|lbox|
      lbox.yscrollcommand proc{|first, last| 
	@v_scroll.set first, last
	idx = lbox.nearest(0)
	@lbox_list.each{|l| l.yview(idx)}
      }
    }
    @v_scroll.command proc{|args| @lbox_list.each{|lbox| lbox.yview *args} }

    # ꥹȥܥåؤΥХǥ
    @mode = {}
    @mode['browse']   = browse_mode_bindtag
    @mode['single']   = single_mode_bindtag
    @mode['extended'] = extended_mode_bindtag
    @mode['multiple'] = multiple_mode_bindtag
    @current_mode = 'browse'
    @lbox_list.each{|l| 
      l.bind('Shift-Key-Left', 
	     proc{|w| focus_shift(w, -1); Tk.callback_break}, '%W')
      l.bind('Shift-Key-Right', 
	     proc{|w| focus_shift(w, 1); Tk.callback_break}, '%W')

      l.bind('Button-2', proc{|x, y| 
	       @lbox_list.each{|lbox| lbox.scan_mark(x, y)}
	     }, '%x %y')
      l.bind('B2-Motion', proc{|x, y| 
	       @lbox_list.each{|lbox| lbox.scan_dragto(x, y)}
	     }, '%x %y')

      l.bindtags(l.bindtags.unshift(@mode[@current_mode]))
    }

    # 
    TkGrid.rowconfigure(@frame, 0, 'weight'=>0)
    TkGrid.rowconfigure(@frame, 1, 'weight'=>1)
    TkGrid.rowconfigure(@frame, 2, 'weight'=>0)
    TkGrid.columnconfigure(@frame, 0, 'weight'=>1)
    TkGrid.columnconfigure(@frame, 1, 'weight'=>0)
    @v_scroll.grid('row'=>1, 'column'=>1, 'sticky'=>'ns')
    @f_title.grid('row'=>0, 'column'=>0, 'sticky'=>'news')
    @f_lbox.grid('row'=>1, 'column'=>0, 'sticky'=>'news')
    @f_hscr.grid('row'=>2, 'column'=>0, 'sticky'=>'ew')

    # ե졼ॵѹΤΥХǥ
    @frame.bind('Configure', proc{reconstruct})

    # ǥեȤΥ᥽åɼդåȤϺǽΥꥹȥܥåȤƤ
    @path = @lbox_list[0].path

    # °
    # С᥽å
    sel_mode = keys.delete('mode')
    mode(sel_mode) if sel_mode

    # СĴ᥽å
    width = keys.delete('scrollbarwidth')
    scrollbarwidth(width) if width

    # ȥ°᥽å
    title_font = keys.delete('titlefont')
    title_fg = keys.delete('titleforeground')
    title_bg = keys.delete('titlebackground')
    if title_font or title_fg or title_bg
      titleconfig(title_font, title_fg, title_bg)
    end

    # °μ
    delegate('DELETE', *@lbox_list)
    delegate('activebackground', @v_scroll, *@hscr_list)
    delegate('troughcolor', @v_scroll, *@hscr_list)
    delegate('repeatdelay', @v_scroll, *@hscr_list)
    delegate('repeatinterval', @v_scroll, *@hscr_list)
    delegate('borderwidth', @frame)
    delegate('relief', @frame)
  end

  # ꥹȥܥå⡼ɤ
  def mode(sel_mode)
    @lbox_list.each{|l| 
      tags = l.bindtags
      tags = tags - [ @mode[@current_mode] ]
      l.bindtags(tags.unshift(@mode[sel_mode]))
      @current_mode = sel_mode
    }
  end

  # СĴ
  def scrollbarwidth(width)
    @v_scroll['width'] = width
    @hscr_list.each{|hscr| hscr['width'] = width}
    @f_hscr['height'] = width + 2 * @v_scroll.cget('borderwidth')
  end

  # ȥ°
  def titleconfig(font, fg, bg)
    keys = {}
    keys['font'] = font if font
    keys['foreground'] = font if fg
    keys['background'] = font if bg
    @title_list.each{|label| label.configure(keys)}
  end

  # ꥫΥȥΥ٥륦åȤ
  def titlelabels(*indexes)
    @title_list[*indexes]
  end

  # ꥫΥꥹȥܥååȤ
  def columns(*indexes)
    @lbox_list[*indexes]
  end

  # ʲϤ٤ƤΥꥹȥܥååȤŬѤ٤᥽åɤκ
  def activate(idx)
    @lbox_list.each{|lbox| lbox.activate(idx)}
  end

  def bbox(idx)
    # ƥꥹȥܥåΥХǥ󥰥ܥåΥꥹȤ֤
    @lbox_list.collect{|lbox| lbox.bbox(idx)}
  end

  def delete(*idx)
    @lbox_list.collect{|lbox| lbox.delete(*idx)}
  end

  def get(*idx)
    if idx.size == 1
      @lbox_list.collect{|lbox| lbox.get(*idx)}
    else
      list = @lbox_list.collect{|lbox| lbox.get(*idx)}
      result = []
      list[0].each_with_index{|line, index|
	result << list.collect{|lines| lines[index]}
      }
      result
    end
  end

  def _line_array_to_hash(line)
    result = {}
    @name_index.each_pair{|label, indexes|
      if indexes.size == 1
	result[label] = line[indexes[0]]
      else
	result[label] = indexes.collect{|index| line[index]}
      end
    }
    result
  end
  private :_line_array_to_hash

  # get η̤٥򥭡Ȥ Hash η֤
  # Ʊ٥뤬¸ߤϤˤͤȤ
  def get_by_hash(*idx)
    get_result = get(*idx)
    if idx.size == 1
      _line_array_to_hash(get_result)
    else
      get_result.collect{|line| _line_array_to_hash(line)}
    end
  end

  def insert(idx, *lines)
    lbox_ins = []
    (0..@lbox_list.size).each{lbox_ins << []}

    lines.each{|line|
      if line.kind_of? Hash
	array = []
	@name_index.each_pair{|label, indexes|
	  if indexes.size == 1
	    array[indexes[0]] = line[label]
	  else
	    if line[label].kind_of? Array
	      indexes.each_with_index{|index, num| 
		array[index] = line[label][num]
	      }
	    else
	      array[indexes[0]] = line[label]
	    end
	  end
	}
	line = array
      end

      @name_index.each_pair{|label, indexes|
	if indexes.size == 1
	  lbox_ins[indexes[0]] << line[indexes[0]]
	else
	  indexes.each{|index| lbox_ins[index] << line[index]}
	end
      }
    }	

    @lbox_list.each_with_index{|lbox, index| 
      lbox.insert(idx, *lbox_ins[index]) if lbox_ins[index]
    }
  end

  def selection_anchor(index)
    @lbox_list.each{|lbox| lbox.selection_anchor(index)}
  end

  def selection_clear(first, last=None)
    @lbox_list.each{|lbox| lbox.selection_clear(first, last=None)}
  end

  def selection_set(first, last=None)
    @lbox_list.each{|lbox| lbox.selection_set(first, last=None)}
  end

  ###########################################
  # ʲ private method
  ###########################################
  private

  # ɽĴ
  def reconstruct
    (0..(@rel_list.size - 2)).each{|idx|
      title, lbox, hscr = @base_list[idx]
      title.place('relwidth'=>@rel_list[idx+1] - @rel_list[idx])
      lbox.place('relwidth'=>@rel_list[idx+1] - @rel_list[idx], 
		 'relheight'=>1.0)
      hscr.place('relwidth'=>@rel_list[idx+1] - @rel_list[idx])

      tab = @tab_list[idx]
      tab.place('relx'=>@rel_list[idx]) if tab
    }
  end

  # ॵѹ
  def resize(x, idx)
    # а֤Ĵ
    delta = (x - @x) / @frame_width
    if delta < @rel_list[idx-1] - @rel_list[idx] + 0.02
      delta = @rel_list[idx-1] - @rel_list[idx] + 0.02
    elsif delta > @rel_list[idx+1] - @rel_list[idx] - 0.02
      delta = @rel_list[idx+1] - @rel_list[idx] - 0.02
    end
    @rel_list[idx] += delta

    # ֤κ¦Ĵ
    title, lbox, hscr = @base_list[idx - 1]
    title.place('relwidth'=>@rel_list[idx] - @rel_list[idx-1])
    lbox.place('relwidth'=>@rel_list[idx] - @rel_list[idx-1], 'relheight'=>1.0)
    hscr.place('relwidth'=>@rel_list[idx] - @rel_list[idx-1])

    # ְ֤Ĵ
    @tab_list[idx].place('relx'=>@rel_list[idx])

    # ֤α¦Ĵ
    title, lbox, hscr = @base_list[idx]
    title.place('relwidth'=>@rel_list[idx+1] - @rel_list[idx], 
		'relx'=>@rel_list[idx])
    lbox.place('relwidth'=>@rel_list[idx+1] - @rel_list[idx], 
	       'relx'=>@rel_list[idx], 'relheight'=>1.0)
    hscr.place('relwidth'=>@rel_list[idx+1] - @rel_list[idx], 
	       'relx'=>@rel_list[idx])

    # ֤ι
    @x = x
  end

  #################################
  # ʲϥХǥ󥰴ط
  #################################
  def browse_mode_bindtag
    t = TkBindTag.new
    t.bind('Button-1', 
	   proc{|w, y| w.focus; select_line(w, w.nearest(y))}, '%W %y')
    t.bind('B1-Motion', proc{|w, y| select_line(w, w.nearest(y))}, '%W %y')

    t.bind('Shift-Button-1', 
	   proc{|w, y| active_line(w, w.nearest(y))}, '%W %y')

    t.bind('Key-Up', proc{|w| select_shift(w, -1)}, '%W')
    t.bind('Key-Down', proc{|w| select_shift(w, 1)}, '%W')

    t.bind('Control-Home', proc{|w| select_line(w, 0)}, '%W')
    t.bind('Control-End', proc{|w| select_line(w, 'end')}, '%W')

    t.bind('space', proc{|w| select_line(w, w.index('active').to_i)}, '%W')
    t.bind('Select', proc{|w| select_line(w, w.index('active').to_i)}, '%W')
    t.bind('Control-slash', 
	   proc{|w| select_line(w, w.index('active').to_i)}, '%W')

    t
  end

  ########################
  def single_mode_bindtag
    t = TkBindTag.new
    t.bind('Button-1', 
	   proc{|w, y| w.focus; select_only(w, w.nearest(y))}, '%W %y')
    t.bind('ButtonRelease-1', 
	   proc{|w, y| active_line(w, w.nearest(y))}, '%W %y')

    t.bind('Shift-Button-1', 
	   proc{|w, y| active_line(w, w.nearest(y))}, '%W %y')

    t.bind('Key-Up', proc{|w| select_shift(w, -1)}, '%W')
    t.bind('Key-Down', proc{|w| select_shift(w, 1)}, '%W')

    t.bind('Control-Home', proc{|w| select_line(w, 0)}, '%W')
    t.bind('Control-End', proc{|w| select_line(w, 'end')}, '%W')

    t.bind('space', proc{|w| select_line(w, w.index('active').to_i)}, '%W')
    t.bind('Select', proc{|w| select_line(w, w.index('active').to_i)}, '%W')
    t.bind('Control-slash', 
	   proc{|w| select_line(w, w.index('active').to_i)}, '%W')
    t.bind('Control-backslash', 
	   proc{@lbox_list.each{|l| l.selection_clear(0, 'end')}})

    t
  end

  ########################
  def extended_mode_bindtag
    t = TkBindTag.new
    t.bind('Button-1', 
	   proc{|w, y| w.focus; select_only(w, w.nearest(y))}, '%W %y')
    t.bind('B1-Motion', proc{|w, y| select_range(w, w.nearest(y))}, '%W %y')

    t.bind('ButtonRelease-1', 
	   proc{|w, y| active_line(w, w.nearest(y))}, '%W %y')

    t.bind('Shift-Button-1', 
	   proc{|w, y| select_range(w, w.nearest(y))}, '%W %y')
    t.bind('Shift-B1-Motion', 
	   proc{|w, y| select_range(w, w.nearest(y))}, '%W %y')

    t.bind('Control-Button-1', 
	   proc{|w, y| select_toggle(w, w.nearest(y))}, '%W %y')

    t.bind('Control-B1-Motion', 
	   proc{|w, y| select_drag(w, w.nearest(y))}, '%W %y')

    t.bind('Key-Up', proc{|w| active_shift(w, -1)}, '%W')
    t.bind('Key-Down', proc{|w| active_shift(w, 1)}, '%W')

    t.bind('Shift-Up', proc{|w| select_expand(w, -1)}, '%W')
    t.bind('Shift-Down', proc{|w| select_expand(w, 1)}, '%W')

    t.bind('Control-Home', proc{|w| select_line2(w, 0)}, '%W')
    t.bind('Control-End', proc{|w| select_line2(w, 'end')}, '%W')

    t.bind('Control-Shift-Home', proc{|w| select_range(w, 0)}, '%W')
    t.bind('Control-Shift-End', proc{|w| select_range(w, 'end')}, '%W')

    t.bind('space', proc{|w| select_active(w)}, '%W')
    t.bind('Select', proc{|w| select_active(w)}, '%W')
    t.bind('Control-slash', proc{|w| select_all}, '%W')
    t.bind('Control-backslash', proc{|w| clear_all}, '%W')

    t
  end

  ########################
  def multiple_mode_bindtag
    t = TkBindTag.new
    t.bind('Button-1', 
	   proc{|w, y| w.focus; select_line3(w, w.nearest(y))}, '%W %y')
    t.bind('ButtonRelease-1', 
	   proc{|w, y| active_line(w, w.nearest(y))}, '%W %y')

    t.bind('Key-Up', proc{|w| active_shift(w, -1)}, '%W')
    t.bind('Key-Down', proc{|w| active_shift(w, 1)}, '%W')

    t.bind('Control-Home', proc{|w| select_line2(w, 0)}, '%W')
    t.bind('Control-End', proc{|w| select_line2(w, 'end')}, '%W')

    t.bind('Control-Shift-Home', proc{|w| active_line(w, 0)}, '%W')
    t.bind('Control-Shift-End', proc{|w| active_line(w, 'end')}, '%W')

    t.bind('space', proc{|w| select_active(w)}, '%W')
    t.bind('Select', proc{|w| select_active(w)}, '%W')
    t.bind('Control-slash', proc{|w| select_all}, '%W')
    t.bind('Control-backslash', proc{|w| clear_all}, '%W')

    t
  end

  ########################
  def active_line(w, idx)
    @lbox_list.each{|l| l.activate(idx)}
  end

  def select_only(w, idx)
    @lbox_list.each{|l|
      l.selection_clear(0, 'end')
      l.selection_anchor(idx)
      l.selection_set('anchor')
    }
  end

  def select_range(w, idx)
    @lbox_list.each{|l|
      l.selection_clear(0, 'end')
      l.selection_set('anchor', idx)
    }
  end

  def select_toggle(w, idx)
    st = w.selection_includes(idx)
    @lbox_list.each{|l|
      l.selection_anchor(idx)
      if st == 1
	l.selection_clear(idx)
      else
	l.selection_set(idx)
      end
    }
  end

  def select_drag(w, idx)
    st = w.selection_includes('anchor')
    @lbox_list.each{|l|
      if st == 1
	l.selection_set('anchor', idx)
      else
	l.selection_clear('anchor', idx)
      end
    }
  end

  def select_line(w, idx)
    @lbox_list.each{|l|
      l.selection_clear(0, 'end')
      l.activate(idx)
      l.selection_anchor(idx)
      l.selection_set('anchor')
    }
    w.selection_set('anchor')
  end

  def select_line2(w, idx)
    @lbox_list.each{|l|
      l.activate(idx)
      l.selection_anchor(idx)
      l.selection_set('anchor')
    }
  end

  def select_line3(w, idx)
    @lbox_list.each{|l|
      l.selection_set(idx)
    }
  end

  def select_active(w)
    idx = l.activate(idx)
    @lbox_list.each{|l|
      l.selection_set(idx)
    }
  end

  def select_expand(w, dir)
    idx = w.index('active').to_i + dir
    if idx < 0
      idx = 0
    elsif idx >= w.size
      idx = w.size - 1
    end
    @lbox_list.each{|l|
      l.activate(idx)
      l.selection_set(idx)
    }
  end

  def active_shift(w, dir)
    idx = w.index('active').to_i + dir
    if idx < 0
      idx = 0
    elsif idx >= w.size
      idx = w.size - 1
    end
    @lbox_list.each{|l|
      l.activate(idx)
      l.selection_anchor(idx)
    }
  end

  def select_shift(w, dir)
    idx = w.index('anchor').to_i + dir
    if idx < 0
      idx = 0
    elsif idx >= w.size
      idx = w.size - 1
    end
    @lbox_list.each{|l|
      l.selection_clear(0, 'end')
      l.activate(idx)
      l.selection_anchor(idx)
      l.selection_set('anchor')
    }
  end

  def select_all
    @lbox_list.each{|l|
      l.selection_set(0, 'end')
    }
  end

  def clear_all
    @lbox_list.each{|l|
      l.selection_clear(0, 'end')
    }
  end

  def focus_shift(w, dir)
    idx = @lbox_list.index(w) + dir
    return if idx < 0
    return if idx >= @lbox_list.size
    @lbox_list[idx].focus
  end
  ########################
end

################################################
# ƥȥ롼
################################################
TEST = false
#TEST = true
if TEST
  f = TkFrame.new(nil, 'width'=>300, 
		  'height'=>200).pack('fill'=>'both', 'expand'=>'true')
  #f = TkFrame.new.pack('fill'=>'both', 'expand'=>'true')
  l = MultiListbox.new(f, 150, 
		       [ ['L1', 100], 
			 ['L2', 200], 
			 ['L3', 50] ]).pack('fill'=>'both', 'expand'=>true)
  l.insert('end', [1,2,3])
  l.insert('end', [4,5,6])
  l.insert('end', [4,5,6], [4,5,6])
  l.insert('end', ['aaaaaaaaaaaaaaa','bbbbbbbbbbbbbb','ccccccccccccccccc'])
  l.insert('end', [1,2,3])
  l.insert('end', [4,5,6], [4,5,6])
  l.insert('end', ['aaaaaaaaaaaaaaa','bbbbbbbbbbbbbb','ccccccccccccccccc'])
  l.insert('end', [1,2,3])
  l.insert('end', [4,5,6], [4,5,6])
  l.insert('end', ['aaaaaaaaaaaaaaa','bbbbbbbbbbbbbb','ccccccccccccccccc'])
  l.insert('end', [1,2,3])
  l.insert('end', [4,5,6], [4,5,6])
  p l.columns(1)
  p l.columns(1..3)
  p l.columns(1,2)
  Tk.mainloop
end
